Special Aircraft Service

Please login or register.

Login with username, password and session length
Advanced search  
Pages: [1] 2 3 4 ... 8   Go Down

Author Topic: Auto DiffFM+ (Updated 2013/01/04)  (Read 40494 times)

0 Members and 1 Guest are viewing this topic.

benitomuso

  • SAS Team
  • member
  • Offline Offline
  • Posts: 2574
  • P.A.L.
Auto DiffFM+ (Updated 2013/01/04)
« on: April 08, 2012, 12:48:13 AM »

***  New Version AutoDiffFM+ for HSFX6 or SAS-ModAct4 (Jan 4th 2013) ***

Since the release of the v4.10m when Team Daidalos decided to encode the buttons with a different keyword, diverse problems arised due to that fact. Old planes, old buttons, former FMs required to be adapted, recoded to the encoding demanded for v4.10m.

The strangest thing is what we know, that from v4.11m they decided to come back to the original keyword. So all the buttons and different FMs we made should be translated again.

To avoid any of these problems and due to the fact that I was kind of sick of it, I decided to make a DiffFM independent of the version.

So: you have buttons in v4.101 it will work, buttons in v4.11, it will work. Some planes having DiffFMs from v4.09m, they will work. New planes from v4.11 with DiffFM they will work too.

To wrap up, the buttons from gui/games can be in any possible format (of the two known to the moment). The individual FMs for planes in development (inside the plane MOD directory) can be in any format too.

For development, I set up a new feature, that at least for me showed to be very useful. I established the next setting in Conf.ini

Code: [Select]
[Mods]
PALButtonsPrefix=

That is the default, and for that you don't have to add anything to your Conf.ini, but if you do something like this:

Code: [Select]
[Mods]
PALButtonsPrefix=test.

Then your game will try to load the FMs from files starting with test. (in this example). So if you have files named:

test.buttons (in the typical gui/game folder), the FMs will be loaded from there and not from your stable buttons, so you don't have to backup anything important.

The same is valid for individual FMs. If in the directory where you have the F4 Phantom you add a file like this:

test.F4E      (under the same example of before, this FM will be loaded preferably to the F4E)

In case there wasn't any "test." FM file, the normal ones (including buttons) are loaded.


Credits to the author of the original DiffFM. As far as I know it is a work of Sani.

Regards,
                    Pablo


PD Updated on Jan 4th 2013:

The people of HSFX6 decided to encode the FMs of their Expert Mode in another format. So finally I added that function to this new version


New AutoDiffFM+ for HSFX6 or SAS-ModAct4 (v4.111 with Jets support):

Download AutoDiffFM+ for HSFX6 or SAS-ModAct4 from here

My MOD which reads FMs from any version making easier try earlier plane MODs in newer versions of the game, etc. This version is only for HSFX6 or SAS-ModAct4. It will not work in plain v4.111 because requires the classes for Jets support.

New Features:
  • Fully compatible with HSFX6 Expert Mode
  • Reads 3 Encoding types: 4.10, 4.11 and HSFX6 Expert Mode
  • Supresses some irrelevant information that plaged the log in original DiffFM
  • Adds extra log information on fails (useful to identify problems of buttons in 60%CTDs, eventual explosion in the air due to problems with .emds, etc.)

PD Updated on Apr the 21st: the 4.101 version is a DBW DiffFM only. It includes the extra features for Jets, etc., as developed by SAS Team. Theorically it will work in UP3 too but not in a Vanilla or standard MODded v4.101.
The v4.111 of the MOD, is not DBW compatible (we still didn't have any DBW for v4.11). So it will work giving you the chance to add any MODded plane (with buttons of any version) to your v4.11 game. It doesn't mean that all will work flawlessly because some other details could be a problem in some particular cases, but most of the MODded planes of v4.101 will work in v4.11 with this one.

 
Old AutoDiffFM for plain v4.111 (will not work fully with HSFX6):

Download Old AutoDiffFM for plain v4.111 from here


EDITED:

Former version of AutoDiffFM compatible with HSFX6 Expert Mode made by chrisgibon:


For those who want to use the expert mode HSFX6 after adding new aircraft I slightly modified the AutoDiffFM mod from Benitomuso.

Download link: http://www.mediafire.com/?e682g4cwn7xcvgu
Logged

Hangman

  • Modder
  • member
  • Offline Offline
  • Posts: 819
Re: Auto DiffFM
« Reply #1 on: April 08, 2012, 01:16:20 AM »

Interesting, so does this mean that I can take plane which is only for 4.09 and install it my DBW and got it work?
Logged

CWMV

  • Kalashnikov connoisseur
  • Modder
  • member
  • Offline Offline
  • Posts: 2706
  • A free people ought to be armed and disciplined.
Re: Auto DiffFM
« Reply #2 on: April 08, 2012, 01:35:05 AM »

Wow...this sounds epic
Logged

SAS~Anto

  • Aussie Bush Pilot
  • Editor
  • member
  • Offline Offline
  • Posts: 4429
  • Retired from modding
Re: Auto DiffFM
« Reply #3 on: April 08, 2012, 02:50:32 AM »

Great idea Pablo :)
Logged

hguderian

  • Modder
  • member
  • Offline Offline
  • Posts: 1127
Re: Auto DiffFM
« Reply #4 on: April 08, 2012, 03:03:53 AM »

Another great step forward!! Thanks benitomuso!
Logged

II/JG51-Lutz

  • member
  • Offline Offline
  • Posts: 156
    • De l'Histoire
Re: Auto DiffFM
« Reply #5 on: April 08, 2012, 04:25:58 AM »

Yes, but.... I am a little bit afraid because a new "standard" for buttons will be create and I am pretty sure that some people will stay with the différent old standards...
It is a marginal point (perhaps I have to think about), but a difffm cannot be integrated inside an SFS.

It is easy to see in the class which call the opening of buttons file to see if it is the good "decoding", as soon as the first bytes are loaded and decoded. If not, restart with a new suffix key.

Doing that, you will have a full compatibility with all versions and you prepare the future in case of in a next patch, DT change again the way of coding.
Remember that DT.dll is not needed to increase performance (seing what is inside) but only a means to increase difficulties to mod.
Logged

Verhängnis

  • Unofficial Heinkel Fan
  • Modder
  • member
  • Offline Offline
  • Posts: 1494
Re: Auto DiffFM
« Reply #6 on: April 08, 2012, 06:42:00 AM »

So does this mean we no longer compile FM's specific for a version, instead we can compile with the 4.09 tool but it will work in 4.10 or 4.11 provided that the end user has the Auto DiffFM?
Logged

mojojojo

  • the only guy who uses the wildcat in multiplayer
  • member
  • Offline Offline
  • Posts: 1367
Re: Auto DiffFM
« Reply #7 on: April 08, 2012, 06:46:05 AM »

wait, so does this make planes that use 4.09 buttons work in 4.10?
Logged
i7 4790K quad core 4.4GHz/8GB DDR3-1600/ASUS Z87-A/ EVGA GTX 970 4GB/128GB A-Data SSD+1TB HDD/EVGA 650w 80+ gold PSU/ NZXT Source 530 gaming case

Hangman

  • Modder
  • member
  • Offline Offline
  • Posts: 819
Re: Auto DiffFM
« Reply #8 on: April 08, 2012, 06:55:18 AM »

Yes you can use only 4.09 planes in your 4.10 installation :)
Logged

mojojojo

  • the only guy who uses the wildcat in multiplayer
  • member
  • Offline Offline
  • Posts: 1367
Re: Auto DiffFM
« Reply #9 on: April 08, 2012, 07:15:13 AM »

Yes you can use only 4.09 planes in your 4.10 installation :)
OH YEAH BABY!!!!!!
thanks bentisumo!!!!!!!!
:)
Logged
i7 4790K quad core 4.4GHz/8GB DDR3-1600/ASUS Z87-A/ EVGA GTX 970 4GB/128GB A-Data SSD+1TB HDD/EVGA 650w 80+ gold PSU/ NZXT Source 530 gaming case

benitomuso

  • SAS Team
  • member
  • Offline Offline
  • Posts: 2574
  • P.A.L.
Re: Auto DiffFM
« Reply #10 on: April 08, 2012, 09:17:31 AM »

People,
                 just a couple of comments:

  As said by others and by me, most of the MODded planes v4.09 will work without any effort in v4.10 and later in v4.11 with this MOD. Nothing extra is required. But there are some (a few) former planes that had any kind of trouble with the transfer from 4.09 to 4.10 not beacuse of the FM but of some methods of the classes. There are some features as the Beacons that would not be handled, because they were not included in the cockpit classes of 4.09 planes.

  In the case of migrating directly planes from 4.10 to 4.11, by using the v4.11 of this MOD (not released yet) I have made some experiments and a very evident problem appears ni Bombers. The bombardier cockpit doesn't move to the bombsight view. People of TD recoded the way the switch to the bombsight view is performed, and our 4.10 cockpits miss a part of code to properly move the sight.

  As most of you know, theorically the reason why TD changed the encoding string for v4.10 was that they introduced some new parameters in the FMs, related to G forces and a Reference Weight. Any plane without that specified will fly perfectly, because the v4.10 onwards code assume some default values.


It is easy to see in the class which call the opening of buttons file to see if it is the good "decoding", as soon as the first bytes are loaded and decoded. If not, restart with a new suffix key.


Lutz, that is exactly what I do here. First I try with the 4.10 encoding, if I can open it, is OK, if not I try with the v4.09/v4.11 one.

If eventually another encoding is established, would be very easy to add other checking in the same structure. We are covered for the future.

So does this mean we no longer compile FM's specific for a version, instead we can compile with the 4.09 tool but it will work in 4.10 or 4.11 provided that the end user has the Auto DiffFM?

Verhängnis,
                       that's correct. If the user has this Auto DiffFM, you can make your MODs in any of the current known encoding versions and it will work. As I stated before: consider that version portability implies something else that a readable buttons. Some features can be lost or produce failures, but you don't have to worry about FMs anymore.

  Regards,
                           Pablo


PD: I was thinking about adding an extra checking in every plane FM opened, that if the newer v4.10 parameters were not present notify the user in the log by saying something as "FM for class AIR.He219 has only v4.09 legacy information, check if there is an updated version for this plane." Obviously AIR.He219 is an example.
Logged

Gaston

  • Modder
  • member
  • Offline Offline
  • Posts: 2715
Re: Auto DiffFM
« Reply #11 on: April 08, 2012, 11:39:43 AM »

This is absolutely interesting ! Thanks, Pablo.

I made a test. You remember the famous Martlet MkI and II, and the A-24 Banshee, which are supposed not to work in 4.101 ? I put this new DiffFM in my UP install, and added these 3 planes, and it is working ! I can fly them !

But for a reason I do not know, when I do the same in my DBW install, the game crashes at 60 %... has someone else tried this ?
Logged
Pages: [1] 2 3 4 ... 8   Go Up
 

Page created in 0.016 seconds with 27 queries.